<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: CMap Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classCMap-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CMap Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class represents a map ( game plan ) with all game objects and entities ( attacker / tower / path / wall etc .  
 <a href="classCMap.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="cmap_8h_source.html">cmap.h</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for CMap:</div>
<div class="dyncontent">
<div class="center"><img src="classCMap__coll__graph.png" border="0" usemap="#CMap_coll__map" alt="Collaboration graph"/></div>
<map name="CMap_coll__map" id="CMap_coll__map">
<area shape="rect" id="node2" href="classCExit.html" title="represents exit, place where attackers are heading " alt="" coords="57,95,111,121"/>
<area shape="rect" id="node3" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="5,5,72,32"/>
<area shape="rect" id="node4" href="structTCoord.html" title="Coordinates, row and col. " alt="" coords="97,5,162,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7ad71523562247ed2183e57eaed018e8"><td class="memItemLeft" align="right" valign="top"><a id="a7ad71523562247ed2183e57eaed018e8"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a7ad71523562247ed2183e57eaed018e8">CMap</a> ()</td></tr>
<tr class="memdesc:a7ad71523562247ed2183e57eaed018e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor, initializes member values. <br /></td></tr>
<tr class="separator:a7ad71523562247ed2183e57eaed018e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a575b3d216be786e78fc203a14c4255ba"><td class="memItemLeft" align="right" valign="top"><a id="a575b3d216be786e78fc203a14c4255ba"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>CMap</b> (const <a class="el" href="classCMap.html">CMap</a> &amp;src)=delete</td></tr>
<tr class="separator:a575b3d216be786e78fc203a14c4255ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9419f5696c22e9569612b79db2872e02"><td class="memItemLeft" align="right" valign="top"><a id="a9419f5696c22e9569612b79db2872e02"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a9419f5696c22e9569612b79db2872e02">~CMap</a> ()</td></tr>
<tr class="memdesc:a9419f5696c22e9569612b79db2872e02"><td class="mdescLeft">&#160;</td><td class="mdescRight">destructor, deletes allocated memory <br /></td></tr>
<tr class="separator:a9419f5696c22e9569612b79db2872e02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa0ec0bdc1eecfe13d04c849bdd732ad"><td class="memItemLeft" align="right" valign="top"><a id="aaa0ec0bdc1eecfe13d04c849bdd732ad"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classCMap.html">CMap</a> &amp;src)=delete</td></tr>
<tr class="separator:aaa0ec0bdc1eecfe13d04c849bdd732ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a81b1455b027bde5aec22ecb2cd043948"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a81b1455b027bde5aec22ecb2cd043948">loadMap</a> (const string &amp;filename)</td></tr>
<tr class="memdesc:a81b1455b027bde5aec22ecb2cd043948"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads a map and fills it with elements from file.  <a href="#a81b1455b027bde5aec22ecb2cd043948">More...</a><br /></td></tr>
<tr class="separator:a81b1455b027bde5aec22ecb2cd043948"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac26b13c84537f825a49154c4a5770adf"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#ac26b13c84537f825a49154c4a5770adf">saveAttackers</a> (ofstream &amp;ofs)</td></tr>
<tr class="memdesc:ac26b13c84537f825a49154c4a5770adf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves every attacker on map to file.  <a href="#ac26b13c84537f825a49154c4a5770adf">More...</a><br /></td></tr>
<tr class="separator:ac26b13c84537f825a49154c4a5770adf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65425056b43f3a075e3853633068df69"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a65425056b43f3a075e3853633068df69">saveTowers</a> (ofstream &amp;ofs)</td></tr>
<tr class="memdesc:a65425056b43f3a075e3853633068df69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves every tower on map to file.  <a href="#a65425056b43f3a075e3853633068df69">More...</a><br /></td></tr>
<tr class="separator:a65425056b43f3a075e3853633068df69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abdfc1587418bbd8831a6531676546c84"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#abdfc1587418bbd8831a6531676546c84">findPaths</a> ()</td></tr>
<tr class="memdesc:abdfc1587418bbd8831a6531676546c84"><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds path to exit for every start in map, stores it into relevant <a class="el" href="classCEntrance.html" title="represents entrance to the map, positions, where attackers can be inserted ">CEntrance</a> Replaces <a class="el" href="classCFreeSpace.html" title="represents free space - place, where tower can be inserted, because attackers don&#39;t move through ther...">CFreeSpace</a> by <a class="el" href="classCPath.html" title="represents the path where attackers are moving ">CPath</a> in map.  <a href="#abdfc1587418bbd8831a6531676546c84">More...</a><br /></td></tr>
<tr class="separator:abdfc1587418bbd8831a6531676546c84"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ea7a54397f9c59ad71336e404a3742f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a2ea7a54397f9c59ad71336e404a3742f">addAttacker</a> (const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;attacker, int entranceNr)</td></tr>
<tr class="memdesc:a2ea7a54397f9c59ad71336e404a3742f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add attacker to entrance specified by second parameter.  <a href="#a2ea7a54397f9c59ad71336e404a3742f">More...</a><br /></td></tr>
<tr class="separator:a2ea7a54397f9c59ad71336e404a3742f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3d713b241ae25ff05d837afd954f1f1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#ad3d713b241ae25ff05d837afd954f1f1">addAttacker</a> (const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;attacker, int entranceNr, int hp, int steps)</td></tr>
<tr class="memdesc:ad3d713b241ae25ff05d837afd954f1f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds attacker to the map, used while loading game.  <a href="#ad3d713b241ae25ff05d837afd954f1f1">More...</a><br /></td></tr>
<tr class="separator:ad3d713b241ae25ff05d837afd954f1f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef9e55cf59ab4910a6038825b764d9f3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#aef9e55cf59ab4910a6038825b764d9f3">addTower</a> (const <a class="el" href="classCTower.html">CTower</a> &amp;tower, int row, int col)</td></tr>
<tr class="memdesc:aef9e55cf59ab4910a6038825b764d9f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds tower to map.  <a href="#aef9e55cf59ab4910a6038825b764d9f3">More...</a><br /></td></tr>
<tr class="separator:aef9e55cf59ab4910a6038825b764d9f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34ef5b5b8e3647c9af99f3ec84ccc822"><td class="memItemLeft" align="right" valign="top"><a id="a34ef5b5b8e3647c9af99f3ec84ccc822"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>attackerCnt</b> () const</td></tr>
<tr class="separator:a34ef5b5b8e3647c9af99f3ec84ccc822"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5e4fc1b61feccf74206750c707a4d6d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#af5e4fc1b61feccf74206750c707a4d6d">move</a> (int maxSp)</td></tr>
<tr class="memdesc:af5e4fc1b61feccf74206750c707a4d6d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns how many attackers are in map.  <a href="#af5e4fc1b61feccf74206750c707a4d6d">More...</a><br /></td></tr>
<tr class="separator:af5e4fc1b61feccf74206750c707a4d6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a678015d1e44f663d9de647dd11441581"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a678015d1e44f663d9de647dd11441581">resetSpeed</a> ()</td></tr>
<tr class="memdesc:a678015d1e44f663d9de647dd11441581"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets speed counter of all attackers to 0.  <a href="#a678015d1e44f663d9de647dd11441581">More...</a><br /></td></tr>
<tr class="separator:a678015d1e44f663d9de647dd11441581"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cfe216c9f40c5e1f3c52a0eee44c63c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a1cfe216c9f40c5e1f3c52a0eee44c63c">displaceTowers</a> (const vector&lt; pair&lt; <a class="el" href="classCTower.html">CTower</a> *, int &gt;&gt; &amp;towers)</td></tr>
<tr class="memdesc:a1cfe216c9f40c5e1f3c52a0eee44c63c"><td class="mdescLeft">&#160;</td><td class="mdescRight">AI which displaces towers at random across the game map.  <a href="#a1cfe216c9f40c5e1f3c52a0eee44c63c">More...</a><br /></td></tr>
<tr class="separator:a1cfe216c9f40c5e1f3c52a0eee44c63c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c365e0f2fd6f5c368416157129f8039"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a6c365e0f2fd6f5c368416157129f8039">attack</a> (bool towers)</td></tr>
<tr class="memdesc:a6c365e0f2fd6f5c368416157129f8039"><td class="mdescLeft">&#160;</td><td class="mdescRight">Performs an attack on every object in each attacker's / tower's distance deletes an attacker/tower if he/it dies.  <a href="#a6c365e0f2fd6f5c368416157129f8039">More...</a><br /></td></tr>
<tr class="separator:a6c365e0f2fd6f5c368416157129f8039"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d105adaa57526c0d6eff53e5765c52e"><td class="memItemLeft" align="right" valign="top"><a id="a8d105adaa57526c0d6eff53e5765c52e"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>width</b> () const</td></tr>
<tr class="separator:a8d105adaa57526c0d6eff53e5765c52e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a1a9f22dff924fdc5ab2f32cca499ae78"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a1a9f22dff924fdc5ab2f32cca499ae78">isWall</a> (char symbol) const</td></tr>
<tr class="memdesc:a1a9f22dff924fdc5ab2f32cca499ae78"><td class="mdescLeft">&#160;</td><td class="mdescRight">exit that are currently in the map  <a href="#a1a9f22dff924fdc5ab2f32cca499ae78">More...</a><br /></td></tr>
<tr class="separator:a1a9f22dff924fdc5ab2f32cca499ae78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa164bc88913e4f4bf195cf5866d50ae1"><td class="memItemLeft" align="right" valign="top">list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#aa164bc88913e4f4bf195cf5866d50ae1">pathToEnd</a> (int x, int y) const</td></tr>
<tr class="memdesc:aa164bc88913e4f4bf195cf5866d50ae1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds a path from [row][col] to end, returns a list of coordinates to get there Throws an exception if end is not reachable from coordinates given as parameters.  <a href="#aa164bc88913e4f4bf195cf5866d50ae1">More...</a><br /></td></tr>
<tr class="separator:aa164bc88913e4f4bf195cf5866d50ae1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a445c3a53ab00befbaf0311c6be138f0b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a445c3a53ab00befbaf0311c6be138f0b">searchMapBFS</a> (vector&lt; vector&lt; int &gt;&gt; &amp;beenThere, int r, int c) const</td></tr>
<tr class="memdesc:a445c3a53ab00befbaf0311c6be138f0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fills an empty 2D vector beenThere using BFS algorithm, stops when end is reached.  <a href="#a445c3a53ab00befbaf0311c6be138f0b">More...</a><br /></td></tr>
<tr class="separator:a445c3a53ab00befbaf0311c6be138f0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5fc08d1b96fb733afc7157b4c3474ab"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#ad5fc08d1b96fb733afc7157b4c3474ab">searchPath</a> (vector&lt; vector&lt; int &gt;&gt; &amp;beenThere, list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; &amp;res, int r, int c, int dst) const</td></tr>
<tr class="memdesc:ad5fc08d1b96fb733afc7157b4c3474ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds actual path and fills list with coordinates using a map filled by BFS.  <a href="#ad5fc08d1b96fb733afc7157b4c3474ab">More...</a><br /></td></tr>
<tr class="separator:ad5fc08d1b96fb733afc7157b4c3474ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0279edd8c7ac41c9f2d486d8c52363ef"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCEntity.html">CEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a0279edd8c7ac41c9f2d486d8c52363ef">readSymbol</a> (char symbol, int xPos)</td></tr>
<tr class="memdesc:a0279edd8c7ac41c9f2d486d8c52363ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines what symbol loaded from map represents, returns an object of class derived from <a class="el" href="classCEntity.html" title="Abstract class, used to store entities to map. ">CEntity</a>, if symbol is entrance / exit stores it into member values for future use.  <a href="#a0279edd8c7ac41c9f2d486d8c52363ef">More...</a><br /></td></tr>
<tr class="separator:a0279edd8c7ac41c9f2d486d8c52363ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e2eee33b6c11437f24016c2a0cbe717"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a2e2eee33b6c11437f24016c2a0cbe717">parseLine</a> (const string &amp;line)</td></tr>
<tr class="memdesc:a2e2eee33b6c11437f24016c2a0cbe717"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parses a string which was read from input file.  <a href="#a2e2eee33b6c11437f24016c2a0cbe717">More...</a><br /></td></tr>
<tr class="separator:a2e2eee33b6c11437f24016c2a0cbe717"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a7a2baaf0b90fd2d4ea5b7398fc2e9971"><td class="memItemLeft" align="right" valign="top"><a id="a7a2baaf0b90fd2d4ea5b7398fc2e9971"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_width</b></td></tr>
<tr class="separator:a7a2baaf0b90fd2d4ea5b7398fc2e9971"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12cc7617b12667ab50d443e43dbede89"><td class="memItemLeft" align="right" valign="top"><a id="a12cc7617b12667ab50d443e43dbede89"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_height</b></td></tr>
<tr class="separator:a12cc7617b12667ab50d443e43dbede89"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6695113821a21ad2d6300d4367334bd5"><td class="memItemLeft" align="right" valign="top"><a id="a6695113821a21ad2d6300d4367334bd5"></a>
vector&lt; vector&lt; <a class="el" href="classCEntity.html">CEntity</a> * &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>m_map</b></td></tr>
<tr class="separator:a6695113821a21ad2d6300d4367334bd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83f276905fd7775cff5caec2213ad4ba"><td class="memItemLeft" align="right" valign="top"><a id="a83f276905fd7775cff5caec2213ad4ba"></a>
vector&lt; <a class="el" href="classCEntrance.html">CEntrance</a> *&gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a83f276905fd7775cff5caec2213ad4ba">m_entrances</a></td></tr>
<tr class="memdesc:a83f276905fd7775cff5caec2213ad4ba"><td class="mdescLeft">&#160;</td><td class="mdescRight">all game objects in 2D vector <br /></td></tr>
<tr class="separator:a83f276905fd7775cff5caec2213ad4ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b4136ff04e5b0a8bdddce35cac2bdc3"><td class="memItemLeft" align="right" valign="top"><a id="a1b4136ff04e5b0a8bdddce35cac2bdc3"></a>
vector&lt; <a class="el" href="classCTower.html">CTower</a> *&gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#a1b4136ff04e5b0a8bdddce35cac2bdc3">m_towers</a></td></tr>
<tr class="memdesc:a1b4136ff04e5b0a8bdddce35cac2bdc3"><td class="mdescLeft">&#160;</td><td class="mdescRight">entrances that are currently in the map <br /></td></tr>
<tr class="separator:a1b4136ff04e5b0a8bdddce35cac2bdc3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aced938754bde134a7328ce07f165a35f"><td class="memItemLeft" align="right" valign="top"><a id="aced938754bde134a7328ce07f165a35f"></a>
vector&lt; <a class="el" href="classCAttacker.html">CAttacker</a> *&gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#aced938754bde134a7328ce07f165a35f">m_attackers</a></td></tr>
<tr class="memdesc:aced938754bde134a7328ce07f165a35f"><td class="mdescLeft">&#160;</td><td class="mdescRight">towers that are currently in the map <br /></td></tr>
<tr class="separator:aced938754bde134a7328ce07f165a35f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4bc5163a72180a278a9632982f94044"><td class="memItemLeft" align="right" valign="top"><a id="ac4bc5163a72180a278a9632982f94044"></a>
<a class="el" href="classCExit.html">CExit</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#ac4bc5163a72180a278a9632982f94044">m_exit</a></td></tr>
<tr class="memdesc:ac4bc5163a72180a278a9632982f94044"><td class="mdescLeft">&#160;</td><td class="mdescRight">attackers that are currently in the map <br /></td></tr>
<tr class="separator:ac4bc5163a72180a278a9632982f94044"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:af020fb7da4218a8b60a68a4967d54190"><td class="memItemLeft" align="right" valign="top">ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMap.html#af020fb7da4218a8b60a68a4967d54190">operator&lt;&lt;</a> (ostream &amp;os, const <a class="el" href="classCMap.html">CMap</a> &amp;map)</td></tr>
<tr class="memdesc:af020fb7da4218a8b60a68a4967d54190"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints whole map with numbered entrances and running attackers.  <a href="#af020fb7da4218a8b60a68a4967d54190">More...</a><br /></td></tr>
<tr class="separator:af020fb7da4218a8b60a68a4967d54190"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class represents a map ( game plan ) with all game objects and entities ( attacker / tower / path / wall etc . </p>
<p>. ) </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a2ea7a54397f9c59ad71336e404a3742f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ea7a54397f9c59ad71336e404a3742f">&#9670;&nbsp;</a></span>addAttacker() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::addAttacker </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;&#160;</td>
          <td class="paramname"><em>attacker</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>entranceNr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Add attacker to entrance specified by second parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">attacker</td><td>object to add to map </td></tr>
    <tr><td class="paramname">entranceNr</td><td>where to place him </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<a id="ad3d713b241ae25ff05d837afd954f1f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3d713b241ae25ff05d837afd954f1f1">&#9670;&nbsp;</a></span>addAttacker() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::addAttacker </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;&#160;</td>
          <td class="paramname"><em>attacker</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>entranceNr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>hp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>steps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds attacker to the map, used while loading game. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">attacker</td><td>source attacker to place in map </td></tr>
    <tr><td class="paramname">entranceNr</td><td>where the attacker started his journey </td></tr>
    <tr><td class="paramname">hp</td><td>how much health has he left </td></tr>
    <tr><td class="paramname">steps</td><td>how many steps has he taken since he entered the map </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<a id="aef9e55cf59ab4910a6038825b764d9f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef9e55cf59ab4910a6038825b764d9f3">&#9670;&nbsp;</a></span>addTower()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::addTower </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classCTower.html">CTower</a> &amp;&#160;</td>
          <td class="paramname"><em>tower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds tower to map. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tower</td><td>to put in map </td></tr>
    <tr><td class="paramname">row</td><td>coordinate </td></tr>
    <tr><td class="paramname">col</td><td>coordinate </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<a id="a6c365e0f2fd6f5c368416157129f8039"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6c365e0f2fd6f5c368416157129f8039">&#9670;&nbsp;</a></span>attack()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CMap::attack </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>towers</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Performs an attack on every object in each attacker's / tower's distance deletes an attacker/tower if he/it dies. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">towers</td><td>- who is being attacked ( true - towers / false - attackers ) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1cfe216c9f40c5e1f3c52a0eee44c63c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cfe216c9f40c5e1f3c52a0eee44c63c">&#9670;&nbsp;</a></span>displaceTowers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::displaceTowers </td>
          <td>(</td>
          <td class="paramtype">const vector&lt; pair&lt; <a class="el" href="classCTower.html">CTower</a> *, int &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>towers</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>AI which displaces towers at random across the game map. </p>
<p>Towers never block attacker's path to end. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">towers</td><td>Vector of available towers along with information how many to displace </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<a id="abdfc1587418bbd8831a6531676546c84"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abdfc1587418bbd8831a6531676546c84">&#9670;&nbsp;</a></span>findPaths()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::findPaths </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Finds path to exit for every start in map, stores it into relevant <a class="el" href="classCEntrance.html" title="represents entrance to the map, positions, where attackers can be inserted ">CEntrance</a> Replaces <a class="el" href="classCFreeSpace.html" title="represents free space - place, where tower can be inserted, because attackers don&#39;t move through ther...">CFreeSpace</a> by <a class="el" href="classCPath.html" title="represents the path where attackers are moving ">CPath</a> in map. </p>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<a id="a1a9f22dff924fdc5ab2f32cca499ae78"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1a9f22dff924fdc5ab2f32cca499ae78">&#9670;&nbsp;</a></span>isWall()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::isWall </td>
          <td>(</td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>exit that are currently in the map </p>
<p>List of Wall characters.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>character to test </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if character represents wall </dd></dl>

</div>
</div>
<a id="a81b1455b027bde5aec22ecb2cd043948"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81b1455b027bde5aec22ecb2cd043948">&#9670;&nbsp;</a></span>loadMap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::loadMap </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Loads a map and fills it with elements from file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>- file to load </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns whether the operation succeeded or not </dd></dl>

</div>
</div>
<a id="af5e4fc1b61feccf74206750c707a4d6d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af5e4fc1b61feccf74206750c707a4d6d">&#9670;&nbsp;</a></span>move()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CMap::move </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>maxSp</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns how many attackers are in map. </p>
<p>Moves all attackers, except those, who are currently sleeping ( their speed is slower than maximum speed and it hasn't been reset yet).</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxSp</td><td>speed of the fastest attacker on map </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>points if attacker got to the end, 0 otherwise </dd></dl>

</div>
</div>
<a id="a2e2eee33b6c11437f24016c2a0cbe717"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2e2eee33b6c11437f24016c2a0cbe717">&#9670;&nbsp;</a></span>parseLine()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::parseLine </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>line</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Parses a string which was read from input file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">line</td><td>string to process </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>false if failed ( size differs or unknown symbol ), true otherwise </dd></dl>

</div>
</div>
<a id="aa164bc88913e4f4bf195cf5866d50ae1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa164bc88913e4f4bf195cf5866d50ae1">&#9670;&nbsp;</a></span>pathToEnd()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; CMap::pathToEnd </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Finds a path from [row][col] to end, returns a list of coordinates to get there Throws an exception if end is not reachable from coordinates given as parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">row</td><td>starting position coordinate </td></tr>
    <tr><td class="paramname">col</td><td>starting position coordinate </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of coordinates to get from row,col to end ( m_endRow, m_endCol) </dd></dl>

</div>
</div>
<a id="a0279edd8c7ac41c9f2d486d8c52363ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0279edd8c7ac41c9f2d486d8c52363ef">&#9670;&nbsp;</a></span>readSymbol()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCEntity.html">CEntity</a> * CMap::readSymbol </td>
          <td>(</td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Determines what symbol loaded from map represents, returns an object of class derived from <a class="el" href="classCEntity.html" title="Abstract class, used to store entities to map. ">CEntity</a>, if symbol is entrance / exit stores it into member values for future use. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>character to process </td></tr>
    <tr><td class="paramname">col</td><td>column where symbol was found </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>entity that is represented by given symbol / nullptr on error </dd></dl>

</div>
</div>
<a id="a678015d1e44f663d9de647dd11441581"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a678015d1e44f663d9de647dd11441581">&#9670;&nbsp;</a></span>resetSpeed()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CMap::resetSpeed </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets speed counter of all attackers to 0. </p>
<dl class="section return"><dt>Returns</dt><dd>speed of the fastest attacker </dd></dl>

</div>
</div>
<a id="ac26b13c84537f825a49154c4a5770adf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac26b13c84537f825a49154c4a5770adf">&#9670;&nbsp;</a></span>saveAttackers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::saveAttackers </td>
          <td>(</td>
          <td class="paramtype">ofstream &amp;&#160;</td>
          <td class="paramname"><em>ofs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saves every attacker on map to file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ofs</td><td>stream to save to </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>false when save fails </dd></dl>

</div>
</div>
<a id="a65425056b43f3a075e3853633068df69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65425056b43f3a075e3853633068df69">&#9670;&nbsp;</a></span>saveTowers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::saveTowers </td>
          <td>(</td>
          <td class="paramtype">ofstream &amp;&#160;</td>
          <td class="paramname"><em>ofs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saves every tower on map to file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ofs</td><td>stream to save to </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>false when save fails </dd></dl>

</div>
</div>
<a id="a445c3a53ab00befbaf0311c6be138f0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a445c3a53ab00befbaf0311c6be138f0b">&#9670;&nbsp;</a></span>searchMapBFS()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int CMap::searchMapBFS </td>
          <td>(</td>
          <td class="paramtype">vector&lt; vector&lt; int &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>beenThere</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sRow</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sCol</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Fills an empty 2D vector beenThere using BFS algorithm, stops when end is reached. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">beenThere</td><td>2D map of distances </td></tr>
    <tr><td class="paramname">beenThere</td><td>2D map of distances </td></tr>
    <tr><td class="paramname">sRow</td><td>starting position row </td></tr>
    <tr><td class="paramname">sCol</td><td>starting position end </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>distance from start to end ( 0 if not reachable ) </dd></dl>

</div>
</div>
<a id="ad5fc08d1b96fb733afc7157b4c3474ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5fc08d1b96fb733afc7157b4c3474ab">&#9670;&nbsp;</a></span>searchPath()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CMap::searchPath </td>
          <td>(</td>
          <td class="paramtype">vector&lt; vector&lt; int &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>beenThere</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>result</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Finds actual path and fills list with coordinates using a map filled by BFS. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">beenThere</td><td>2D map of distances filled by BFS </td></tr>
    <tr><td class="paramname">result</td><td>list where the resulting path is stored </td></tr>
    <tr><td class="paramname">row</td><td>current position in recursion - coordinate </td></tr>
    <tr><td class="paramname">col</td><td>current position in recursion - coordinate </td></tr>
    <tr><td class="paramname">dst</td><td>current distance in recursion - coordinate </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list filled with coordinates, empty if not reachable ( shouldn't occur! ) </dd></dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="af020fb7da4218a8b60a68a4967d54190"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af020fb7da4218a8b60a68a4967d54190">&#9670;&nbsp;</a></span>operator<<</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classCMap.html">CMap</a> &amp;&#160;</td>
          <td class="paramname"><em>map</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints whole map with numbered entrances and running attackers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">map</td><td>to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="cmap_8h_source.html">cmap.h</a></li>
<li>cmap.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
